# Security Policy

## Supported Versions

Security updates are provided only for the current minor version.

If you are using a previous minor version, we recommend to upgrade to the current minor version.
This project uses [semantic versioning](https://semver.org/), therefore you can upgrade to a more recent minor version without incurring into breaking changes.

Exceptionally, we may support previous minor versions upon request if there are significant reasons preventing to immediately switch the latest minor version.

Older major versions are no longer supported.


## Reporting a Vulnerability

To make a report, please email weppos@weppos.net.

> [!IMPORTANT]  
> Please consider encrypting your report with GPG using the key [0x420da82a989398df](https://keyserver.ubuntu.com/pks/lookup?op=get&search=0x420da82a989398df).


## Tracking Security Updates

Information about security vulnerabilities are published in the [Security Advisories](https://github.com/weppos/publicsuffix-ruby/security/advisories) page.
